@using Entities
@using Business
@using DataAccess


@inject IDbContextFactory<inventory_context> ContextFactory

@if (DataLoading)
{
    <h4>@loading_message</h4>
}

<div>
    <EditForm Model="oStorage">
        <div class="form-group">
            <label for="">Bodegas:</label>
            <InputSelect class="form-control" @bind-Value="oStorage.WarehouseId">
                @foreach (var warehouse in warehouses)
                {
                    <option value="none" selected disabled hidden>Elige una Bodega ..</option>
                    <option value="@warehouse.WarehouseId">@warehouse.WarehouseName</option>
                }
            </InputSelect>
        </div>
        <br>

        <div class="form-group">
            <label for="">Productos:</label>
            <InputSelect class="form-control" @bind-Value="oStorage.ProdId">
                @foreach (var product in products)
                {
                    <option value="none" selected disabled hidden>Elige un Producto ..</option>
                    <option value="@product.ProdId">@product.ProdName</option>
                }
            </InputSelect>

        </div>
        <br>

        <input type="button" value="Agregar Producto" @onclick="SaveStorage">

    </EditForm>
</div>
<br>

<div>
    <b>@storage_message</b>
</div>

@code
{
    private bool DataLoading = false;
    private string loading_message = "Fetching Storage data from DB..";
    private string storage_message = string.Empty;

    B_Storage bStorage = null!;
    Storage oStorage = new();

    B_Warehouse bWarehouse = null!;
    List<Warehouse> warehouses = new ();

    B_Product bProduct = null!;
    List<Product> products = new ();

    protected override async Task OnInitializedAsync()
    {
        if (DataLoading)
        {
            return;
        }

        try
        {
            bStorage = new (ContextFactory);
            bWarehouse = new (ContextFactory);
            bProduct = new (ContextFactory);

            if (bWarehouse is not null && bProduct is not null)
            {
                warehouses = await bWarehouse.GetWarehouses();
                products = await bProduct.GetProducts();
            }
        }
        catch (System.Exception ex)
        {
            throw ex;
        }
        finally
        {
            DataLoading = false;
        }


        await base.OnInitializedAsync();
    }

    private async Task SaveStorage()
    {
        if (bStorage is not null 
                && oStorage.ProdId is not null && oStorage.WarehouseId is not null
        )
        {
            if (!await bStorage.IsProductInWarehouse((int)oStorage.ProdId, (int)oStorage.WarehouseId))
            {
                oStorage.LastUpdate = DateTime.UtcNow;
                await bStorage.CreateStorage(oStorage);
                oStorage = new(); // Clean User's Input
                StateHasChanged();

                storage_message = "Tu producto ha sido guardado con exito en la Bodega";
            }
            else
            {
                storage_message = "Tu producto ya se encuenta en la Bodega";
                oStorage = new(); // Clean User's Input
                StateHasChanged();
            }
        }

    }
}